#include "pktfec.h"

#include <stdlib.h>
#include <stdio.h>

int main(int argc, char **argv) {
  uint8_t *input;
  size_t inputlen = 0;
  size_t buflen = 64;
  uint8_t *output;
  size_t outputlen;
  input = malloc(buflen);
  while (1) {
    if (!input) return 1;
    inputlen += fread(input+inputlen, 1, buflen-inputlen, stdin);
    if (ferror(stdin)) return 1;
    if (feof(stdin)) break;
    buflen *= 2;
    input = realloc(input, buflen);
  }
  outputlen = pktfec_encode(NULL, NULL, inputlen);
  if (!outputlen) return 1;
  output = malloc(outputlen);
  if (!output) return 1;
  pktfec_encode(output, input, inputlen);
  fwrite(output, 1, outputlen, stdout);
  if (ferror(stdout)) return 1;
  return 0;
}
